#include<bits/stdc++.h>
#define ll long long
#define pb push_back
#define ff first
#define ss second
using namespace std;
ll t,n,m,a[75005],b[75005],x,mod;
bool q;
ll gcd(ll a,ll b){
  if (a==0)
    return b;
  return gcd(b%a,a);
}
int main () {
cin.tie(NULL);
ios_base::sync_with_stdio(false);
cin>>t;
while(t--){
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    for(int i=1;i<=m;i++){
        cin>>b[i];
    }
    sort(a+1,a+n+1);
    x=a[2]-a[1];
    for(int i=3;i<=n;i++){
        x=gcd(x,a[i]-a[i-1]);
    }
    mod=a[1]%x;
    q=true;
    for(int i=3;i<=n;i++){
        if((a[i]-a[i-1])%x!=0){
            q=false;
            break;
        }
    }
    for (int i=1;i<=m;i++){
        if(b[i]%x==mod){
            q=false;
            break;
        }
    }
    if(q){
        cout<<1<<endl;
    }
    else {
        cout<<0<<endl;
    }
}
return 0;
}